------------------------------------------------------------------------------
--                              G N A T C O L L                             --
--                                                                          --
--                     Copyright (C) 2022-2023, AdaCore                     --
--                                                                          --
-- This library is free software;  you can redistribute it and/or modify it --
-- under terms of the  GNU General Public License  as published by the Free --
-- Software  Foundation;  either version 3,  or (at your  option) any later --
-- version. This library is distributed in the hope that it will be useful, --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            --
--                                                                          --
-- As a special exception under Section 7 of GPL version 3, you are granted --
-- additional permissions described in the GCC Runtime Library Exception,   --
-- version 3.1, as published by the Free Software Foundation.               --
--                                                                          --
-- You should have received a copy of the GNU General Public License and    --
-- a copy of the GCC Runtime Library Exception along with this program;     --
-- see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    --
-- <http://www.gnu.org/licenses/>.                                          --
--                                                                          --
------------------------------------------------------------------------------

--  Posix Interface to utime system call

with GNATCOLL.OS.FS; use GNATCOLL.OS.FS;
package GNATCOLL.OS.Libc.Utime is

   type Timespec is record
      TV_Sec  : Interfaces.C.long;
      TV_NSec : Interfaces.C.long;
   end record;

   type Timespec_Array_Idx is range 1 .. 2;
   type Timespec_Array is array (Timespec_Array_Idx) of Timespec;

   --  See Posix futimens documentation
   function Futimens
     (FD : File_Descriptor; Timespecs : in out Timespec_Array)
      return Libc_Status with
     Import => True, Convention => C, External_Name => "__gnatcoll_futimens";

end GNATCOLL.OS.Libc.Utime;
